#include "sys.h"
#include "mmc_sd.h"
#include "spi.h"
#include "usart.h"
#include "delay.h" 							   
u8  SD_Type=0;//SD
//Mini STM32
//SD 
//ԭ@ALIENTEK

//2010/5/13									   
//һЩʱ,ʵ֧TF(1G),ʿ2G,4G 16G SD
//2010/6/24
//u8 SD_GetResponse(u8 Response)
//޸u8 SD_WaitDataReady(void)
//USBֵ֧u8 MSD_ReadBuffer(u8* pBuffer, u32 ReadAddr, u32 NumByteToRead);
//u8 MSD_WriteBuffer(u8* pBuffer, u32 WriteAddr, u32 NumByteToWrite);


//ȴSDӦ
//Response:ҪõĻӦֵ
//ֵ:0,ɹõ˸ûӦֵ
//    ,õӦֵʧ
u8 SD_GetResponse(u8 Response)
{
	u16 Count=0xFFF;//ȴ	   						  
	while ((SPIx_ReadWriteByte(0XFF)!=Response)&&Count)Count--;//ȴõ׼ȷĻӦ  	  
	if (Count==0)return MSD_RESPONSE_FAILURE;//õӦʧ   
	else return MSD_RESPONSE_NO_ERROR;//ȷӦ
}
//ȴSDд
//ֵ:0,ɹ;   
//    ,;
u8 SD_WaitDataReady(void)
{
    u8 r1=MSD_DATA_OTHER_ERROR;
    u32 retry;
    retry=0;
    do
    {
        r1=SPIx_ReadWriteByte(0xFF)&0X1F;//Ӧ
        if(retry==0xfffe)return 1; 
		retry++;
		switch (r1)
		{					   
			case MSD_DATA_OK://ݽȷ	 
				r1=MSD_DATA_OK;
				break;  
			case MSD_DATA_CRC_ERROR:  //CRCУ
				return MSD_DATA_CRC_ERROR;  
			case MSD_DATA_WRITE_ERROR://д
				return MSD_DATA_WRITE_ERROR;  
			default://δ֪    
				r1=MSD_DATA_OTHER_ERROR;
				break;	 
		}   
    }while(r1==MSD_DATA_OTHER_ERROR); //ݴʱһֱȴ
	retry=0;
	while(SPIx_ReadWriteByte(0XFF)==0)//Ϊ0,ݻδд
	{
		retry++;
		//delay_us(10);//SDдȴҪϳʱ
		if(retry>=0XFFFFFFFE)return 0XFF;//ȴʧ
	};	    
    return 0;//ɹ
}	 
//SDһ
//: u8 cmd    
//      u32 arg  
//      u8 crc   crcУֵ	   
//ֵ:SDصӦ															  
u8 SD_SendCommand(u8 cmd, u32 arg, u8 crc)
{
    u8 r1;	
	u8 Retry=0;	         
	SD_CS=1;
    SPIx_ReadWriteByte(0xff);//дʱ
	SPIx_ReadWriteByte(0xff);     
 	SPIx_ReadWriteByte(0xff);  	 
    //ƬѡõͣѡSD
    SD_CS=0; 
    //
    SPIx_ReadWriteByte(cmd | 0x40);//ֱд
    SPIx_ReadWriteByte(arg >> 24);
    SPIx_ReadWriteByte(arg >> 16);
    SPIx_ReadWriteByte(arg >> 8);
    SPIx_ReadWriteByte(arg);
    SPIx_ReadWriteByte(crc); 
    //ȴӦʱ˳
    while((r1=SPIx_ReadWriteByte(0xFF))==0xFF)
    {
        Retry++;	    
        if(Retry>200)break; 
    }   
    //رƬѡ
    SD_CS=1;
    //϶8ʱӣSDʣµĹ
    SPIx_ReadWriteByte(0xFF);
    //״ֵ̬
    return r1;
}		  																				 
//SDһ(ǲʧƬѡкݴ
//:u8 cmd    
//     u32 arg  
//     u8 crc   crcУֵ	 
//ֵ:SDصӦ															  
u8 SD_SendCommand_NoDeassert(u8 cmd, u32 arg, u8 crc)
{
	u8 Retry=0;	         
	u8 r1;			   
    SPIx_ReadWriteByte(0xff);//дʱ
	SPIx_ReadWriteByte(0xff);  	 	 
    SD_CS=0;//ƬѡõͣѡSD	   
    //
    SPIx_ReadWriteByte(cmd | 0x40); //ֱд
    SPIx_ReadWriteByte(arg >> 24);
    SPIx_ReadWriteByte(arg >> 16);
    SPIx_ReadWriteByte(arg >> 8);
    SPIx_ReadWriteByte(arg);
    SPIx_ReadWriteByte(crc);   
    //ȴӦʱ˳
    while((r1=SPIx_ReadWriteByte(0xFF))==0xFF)
    {
        Retry++;	    
        if(Retry>200)break; 
    }  	  
    //Ӧֵ
    return r1;
}
//SDõģʽ
//ֵ:0,ɹ
//       1,ʧ
u8 SD_Idle_Sta(void)
{
	u16 i;
	u8 retry;	   	  
    for(i=0;i<0xf00;i++);//ʱȴSDϵ	 
    //Ȳ>74壬SDԼʼ
    for(i=0;i<10;i++)SPIx_ReadWriteByte(0xFF); 
    //-----------------SDλidleʼ-----------------
    //ѭCMD0ֱSD0x01,IDLE״̬
    //ʱֱ˳
    retry = 0;
    do
    {	   
        //CMD0SDIDLE״̬
        i = SD_SendCommand(CMD0, 0, 0x95);
        retry++;
    }while((i!=0x01)&&(retry<200));
    //ѭ󣬼ԭ򣺳ʼɹor Գʱ
    if(retry==200)return 1; //ʧ
	return 0;//ɹ	 						  
}														    
//ʼSD
//ɹ,ԶSPIٶΪ18Mhz
//ֵ:0NO_ERR
//       1TIME_OUT
//      99NO_CARD																 
u8 SD_Init(void)
{								 
    u8 r1;      // SDķֵ
    u16 retry;  // гʱ
    u8 buff[6];
    //ӲSDĿ
	//NRF24L01/W25X16ȵӰ
	RCC->APB2ENR|=1<<2;       //PORTAʱʹ 
	GPIOA->CRL&=0XFFF000FF; 
	GPIOA->CRL|=0X00033300;//PA2.3.4  	    
	GPIOA->ODR|=0X7<<2;    //PA2.3.4 
	SPIx_Init();
 	SPIx_SetSpeed(SPI_SPEED_256);//õģʽ		 
	SD_CS=1;	
    if(SD_Idle_Sta()) return 1;//ʱ1 õidle ģʽʧ	  
    //-----------------SDλidle-----------------	 
    //ȡƬSD汾Ϣ
 	SD_CS=0;	
	r1 = SD_SendCommand_NoDeassert(8, 0x1aa,0x87);	     
    //Ƭ汾Ϣv1.0汾ģr1=0x05³ʼ
    if(r1 == 0x05)
    {
        //ÿΪSDV1.0⵽ΪMMC޸ΪMMC
        SD_Type = SD_TYPE_V1;	   
        //V1.0CMD8ָûк
        //Ƭѡøߣ
        SD_CS=1;
        //෢8CLKSD
        SPIx_ReadWriteByte(0xFF);	  
        //-----------------SDMMCʼʼ-----------------	 
        //ʼָCMD55+ACMD41
        // Ӧ˵SDҳʼ
        // ûлӦ˵MMCӦʼ
        retry = 0;
        do
        {
            //ȷCMD55Ӧ0x01
            r1 = SD_SendCommand(CMD55, 0, 0);
            if(r1 == 0XFF)return r1;//ֻҪ0xff,ͽŷ	  
            //õȷӦ󣬷ACMD41Ӧõֵ0x00200
            r1 = SD_SendCommand(ACMD41, 0, 0);
            retry++;
        }while((r1!=0x00) && (retry<400));
        // жǳʱǵõȷӦ
        // лӦSDûлӦMMC	  
        //----------MMCʼʼ------------
        if(retry==400)
        {
            retry = 0;
            //MMCʼûвԣ
            do
            {
                r1 = SD_SendCommand(1,0,0);
                retry++;
            }while((r1!=0x00)&& (retry<400));
            if(retry==400)return 1;   //MMCʼʱ		    
            //д뿨
            SD_Type = SD_TYPE_MMC;
        }
        //----------MMCʼ------------	    
        //SPIΪģʽ
        SPIx_SetSpeed(SPI_SPEED_4);   
		SPIx_ReadWriteByte(0xFF);	 
        //ֹCRCУ	   
		r1 = SD_SendCommand(CMD59, 0, 0x95);
        if(r1 != 0x00)return r1;  //󣬷r1   	   
        //Sector Size
        r1 = SD_SendCommand(CMD16, 512, 0x95);
        if(r1 != 0x00)return r1;//󣬷r1		 
        //-----------------SDMMCʼ-----------------

    }//SDΪV1.0汾ĳʼ	 
    //V2.0ĳʼ
    //ҪȡOCRݣжSD2.0SD2.0HC
    else if(r1 == 0x01)
    {
        //V2.0ĿCMD8ᴫ4ֽڵݣҪٽ
        buff[0] = SPIx_ReadWriteByte(0xFF);  //should be 0x00
        buff[1] = SPIx_ReadWriteByte(0xFF);  //should be 0x00
        buff[2] = SPIx_ReadWriteByte(0xFF);  //should be 0x01
        buff[3] = SPIx_ReadWriteByte(0xFF);  //should be 0xAA	    
        SD_CS=1;	  
        SPIx_ReadWriteByte(0xFF);//the next 8 clocks			 
        //жϸÿǷ֧2.7V-3.6VĵѹΧ
        //if(buff[2]==0x01 && buff[3]==0xAA) //жϣֵ֧Ŀ
        {	  
            retry = 0;
            //ʼָCMD55+ACMD41
    		do
    		{
    			r1 = SD_SendCommand(CMD55, 0, 0);
    			if(r1!=0x01)return r1;	   
    			r1 = SD_SendCommand(ACMD41, 0x40000000, 0);
                if(retry>200)return r1;  //ʱ򷵻r1״̬  
            }while(r1!=0);		  
            //ʼָɣȡOCRϢ		   
            //-----------SD2.0汾ʼ-----------
            r1 = SD_SendCommand_NoDeassert(CMD58, 0, 0);
            if(r1!=0x00)
			{
				SD_CS=1;//ͷSDƬѡź
				return r1;  //ûзȷӦֱ˳Ӧ	 
			}//OCRָ󣬽4ֽڵOCRϢ
            buff[0] = SPIx_ReadWriteByte(0xFF);
            buff[1] = SPIx_ReadWriteByte(0xFF); 
            buff[2] = SPIx_ReadWriteByte(0xFF);
            buff[3] = SPIx_ReadWriteByte(0xFF);		 
            //OCRɣƬѡø
            SD_CS=1;
            SPIx_ReadWriteByte(0xFF);	   
            //յOCRеbit30λCCSȷΪSD2.0SDHC
            //CCS=1SDHC   CCS=0SD2.0
            if(buff[0]&0x40)SD_Type = SD_TYPE_V2HC;    //CCS	 
            else SD_Type = SD_TYPE_V2;	    
            //-----------SD2.0汾----------- 
            //SPIΪģʽ
            SPIx_SetSpeed(SPI_SPEED_4);  
        }	    
    }
    return r1;
}	 																			   
//SDжָȵݣڸλ
//: u8 *data(Ŷݵڴ>len)
//      u16 len(ݳȣ
//      u8 release(ɺǷͷCSø 0ͷ 1ͷţ	 
//ֵ:0NO_ERR
//  	 otherϢ														  
u8 SD_ReceiveData(u8 *data, u16 len, u8 release)
{
    // һδ
    SD_CS=0;				  	  
	if(SD_GetResponse(0xFE))//ȴSDʼ0xFE
	{	  
		SD_CS=1;
		return 1;
	}
    while(len--)//ʼ
    {
        *data=SPIx_ReadWriteByte(0xFF);
        data++;
    }
    //2αCRCdummy CRC
    SPIx_ReadWriteByte(0xFF);
    SPIx_ReadWriteByte(0xFF);
    if(release==RELEASE)//ͷߣCSø
    {
        SD_CS=1;//
        SPIx_ReadWriteByte(0xFF);
    }											  					    
    return 0;
}																				  
//ȡSDCIDϢϢ
//: u8 *cid_data(CIDڴ棬16Byte	  
//ֵ:0NO_ERR
//		 1TIME_OUT
//       otherϢ														   
u8 SD_GetCID(u8 *cid_data)
{
    u8 r1;	   
    //CMD10CID
    r1 = SD_SendCommand(CMD10,0,0xFF);
    if(r1 != 0x00)return r1;  //ûȷӦ˳  
    SD_ReceiveData(cid_data,16,RELEASE);//16ֽڵ	 
    return 0;
}																				  
//ȡSDCSDϢٶϢ
//:u8 *cid_data(CIDڴ棬16Byte	    
//ֵ:0NO_ERR
//       1TIME_OUT
//       otherϢ														   
u8 SD_GetCSD(u8 *csd_data)
{
    u8 r1;	 
    r1=SD_SendCommand(CMD9,0,0xFF);//CMD9CSD
    if(r1)return r1;  //ûȷӦ˳  
    SD_ReceiveData(csd_data, 16, RELEASE);//16ֽڵ 
    return 0;
}  
//ȡSDֽڣ   
//ֵ:0 ȡ 
//       :SD(ֽ)														  
u32 SD_GetCapacity(void)
{
    u8 csd[16];
    u32 Capacity;
    u8 r1;
    u16 i;
	u16 temp;  					    
	//ȡCSDϢڼ0
    if(SD_GetCSD(csd)!=0) return 0;	    
    //ΪSDHC淽ʽ
    if((csd[0]&0xC0)==0x40)
    {									  
	    Capacity=((u32)csd[8])<<8;
		Capacity+=(u32)csd[9]+1;	 
        Capacity = (Capacity)*1024;//õ
		Capacity*=512;//õֽ			   
    }
    else
    {		    
    	i = csd[6]&0x03;
    	i<<=8;
    	i += csd[7];
    	i<<=2;
    	i += ((csd[8]&0xc0)>>6);
        //C_SIZE_MULT
    	r1 = csd[9]&0x03;
    	r1<<=1;
    	r1 += ((csd[10]&0x80)>>7);	 
    	r1+=2;//BLOCKNR
    	temp = 1;
    	while(r1)
    	{
    		temp*=2;
    		r1--;
    	}
    	Capacity = ((u32)(i+1))*((u32)temp);	 
        // READ_BL_LEN
    	i = csd[5]&0x0f;
        //BLOCK_LEN
    	temp = 1;
    	while(i)
    	{
    		temp*=2;
    		i--;
    	}
        //The final result
    	Capacity *= (u32)temp;//ֽΪλ 	  
    }
    return (u32)Capacity;
}	    																			    
//SDһblock
//:u32 sector ȡַsectorֵַ 
//     u8 *buffer ݴ洢ַС512byte 		   
//ֵ:0 ɹ
//       otherʧ															  
u8 SD_ReadSingleBlock(u32 sector, u8 *buffer)
{
	u8 r1;	    
    //Ϊģʽ
    SPIx_SetSpeed(SPI_SPEED_4);  		   
    //SDHCsectorַתbyteַ
    if(SD_Type!=SD_TYPE_V2HC)
    {
        sector = sector<<9;
    } 
	r1 = SD_SendCommand(CMD17, sector, 0);//	 		    
	if(r1 != 0x00)return r1; 		   							  
	r1 = SD_ReceiveData(buffer, 512, RELEASE);		 
	if(r1 != 0)return r1;   //ݳ
    else return 0; 
}
////////////////////////////2ΪUSBдҪ/////////////////////////
//SDĿС	 				   
#define BLOCK_SIZE 512 
//дMSD/SD 
//pBuffer:ݴ
//ReadAddr:д׵ַ
//NumByteToRead:Ҫдֽ
//ֵ:0,д
//    ,дʧ
u8 MSD_WriteBuffer(u8* pBuffer, u32 WriteAddr, u32 NumByteToWrite)
{
	u32 i,NbrOfBlock = 0, Offset = 0;
	u32 sector;
	u8 r1;
   	NbrOfBlock = NumByteToWrite / BLOCK_SIZE;//õҪдĿĿ	    
    SD_CS=0;	  		   
	while (NbrOfBlock--)//дһ
	{
		sector=WriteAddr+Offset;
		if(SD_Type==SD_TYPE_V2HC)sector>>=9;//ִͨ෴Ĳ					  			 
		r1=SD_SendCommand_NoDeassert(CMD24,sector,0xff);//д   
 		if(r1)
		{
			SD_CS=1;
			return 1;//Ӧȷֱӷ 	   
	    }
	    SPIx_ReadWriteByte(0xFE);//ʼ0xFE   
	    //һsector
	    for(i=0;i<512;i++)SPIx_ReadWriteByte(*pBuffer++);  
	    //2Bytedummy CRC
	    SPIx_ReadWriteByte(0xff);
	    SPIx_ReadWriteByte(0xff); 
 		if(SD_WaitDataReady())//ȴSDд
		{
			SD_CS=1;
			return 2;    
		}
		Offset += 512;	   
	}	    
    //дɣƬѡ1
    SD_CS=1;
    SPIx_ReadWriteByte(0xff);	 
    return 0;
}
//ȡMSD/SD 
//pBuffer:ݴ
//ReadAddr:ȡ׵ַ
//NumByteToRead:Ҫֽ
//ֵ:0,
//    ,ʧ
u8 MSD_ReadBuffer(u8* pBuffer, u32 ReadAddr, u32 NumByteToRead)
{
	u32 NbrOfBlock=0,Offset=0;
	u32 sector=0;
	u8 r1=0;   	 
  	NbrOfBlock=NumByteToRead/BLOCK_SIZE;	  
    SD_CS=0;
	while (NbrOfBlock --)
	{	
		sector=ReadAddr+Offset;
		if(SD_Type==SD_TYPE_V2HC)sector>>=9;//ִͨ෴Ĳ					  			 
		r1=SD_SendCommand_NoDeassert(CMD17,sector,0xff);//	 		    
		if(r1)//ʹ
		{
    		SD_CS=1;
			return r1;
		}	   							  
		r1=SD_ReceiveData(pBuffer,512,RELEASE);		 
		if(r1)//
		{
    		SD_CS=1;
			return r1;
		}
		pBuffer+=512;	 					    
	  	Offset+=512;				 	 
	}	 	 
    SD_CS=1;
    SPIx_ReadWriteByte(0xff);	 
    return 0;
}
//////////////////////////////////////////////////////////////////////////
//дSDһblock(δʵʲԹ)										    
//:u32 sector ַsectorֵַ 
//     u8 *buffer ݴ洢ַС512byte 		   
//ֵ:0 ɹ
//       otherʧ															  
u8 SD_WriteSingleBlock(u32 sector, const u8 *data)
{
    u8 r1;
    u16 i;
    u16 retry;

    //Ϊģʽ
    //SPIx_SetSpeed(SPI_SPEED_HIGH);	   
    //SDHCsectorַתbyteַ
    if(SD_Type!=SD_TYPE_V2HC)
    {
        sector = sector<<9;
    }   
    r1 = SD_SendCommand(CMD24, sector, 0x00);
    if(r1 != 0x00)
    {
        return r1;  //Ӧȷֱӷ
    }
    
    //ʼ׼ݴ
    SD_CS=0;
    //ȷ3ݣȴSD׼
    SPIx_ReadWriteByte(0xff);
    SPIx_ReadWriteByte(0xff);
    SPIx_ReadWriteByte(0xff);
    //ʼ0xFE
    SPIx_ReadWriteByte(0xFE);

    //һsector
    for(i=0;i<512;i++)
    {
        SPIx_ReadWriteByte(*data++);
    }
    //2Bytedummy CRC
    SPIx_ReadWriteByte(0xff);
    SPIx_ReadWriteByte(0xff);
    
    //ȴSDӦ
    r1 = SPIx_ReadWriteByte(0xff);
    if((r1&0x1F)!=0x05)
    {
        SD_CS=1;
        return r1;
    }
    
    //ȴ
    retry = 0;
    while(!SPIx_ReadWriteByte(0xff))
    {
        retry++;
        if(retry>0xfffe)        //ʱдûɣ˳
        {
            SD_CS=1;
            return 1;           //д볬ʱ1
        }
    }	    
    //дɣƬѡ1
    SD_CS=1;
    SPIx_ReadWriteByte(0xff);

    return 0;
}				           
//SDĶblock(ʵʲԹ)										    
//:u32 sector ַsectorֵַ 
//     u8 *buffer ݴ洢ַС512byte
//     u8 count countblock 		   
//ֵ:0 ɹ
//       otherʧ															  
u8 SD_ReadMultiBlock(u32 sector, u8 *buffer, u8 count)
{
    u8 r1;	 			 
    //SPIx_SetSpeed(SPI_SPEED_HIGH);//Ϊģʽ  
 	//SDHCsectorַתbyteַ
    if(SD_Type!=SD_TYPE_V2HC)sector = sector<<9;  
    //SD_WaitDataReady();
    //
	r1 = SD_SendCommand(CMD18, sector, 0);//
	if(r1 != 0x00)return r1;	 
    do//ʼ
    {
        if(SD_ReceiveData(buffer, 512, NO_RELEASE) != 0x00)break; 
        buffer += 512;
    } while(--count);		 
    //ȫϣֹͣ
    SD_SendCommand(CMD12, 0, 0);
    //ͷ
    SD_CS=1;
    SPIx_ReadWriteByte(0xFF);    
    if(count != 0)return count;   //ûд꣬ʣ	 
    else return 0;	 
}											  
//дSDNblock(δʵʲԹ)									    
//:u32 sector ַsectorֵַ 
//     u8 *buffer ݴ洢ַС512byte
//     u8 count дblockĿ		   
//ֵ:0 ɹ
//       otherʧ															   
u8 SD_WriteMultiBlock(u32 sector, const u8 *data, u8 count)
{
    u8 r1;
    u16 i;	 		 
    //SPIx_SetSpeed(SPI_SPEED_HIGH);//Ϊģʽ	 
    if(SD_Type != SD_TYPE_V2HC)sector = sector<<9;//SDHCsectorַתbyteַ  
    if(SD_Type != SD_TYPE_MMC) r1 = SD_SendCommand(ACMD23, count, 0x00);//Ŀ꿨MMCACMD23ָʹԤ   
    r1 = SD_SendCommand(CMD25, sector, 0x00);//дָ
    if(r1 != 0x00)return r1;  //Ӧȷֱӷ	 
    SD_CS=0;//ʼ׼ݴ   
    SPIx_ReadWriteByte(0xff);//ȷ3ݣȴSD׼
    SPIx_ReadWriteByte(0xff);   
    //--------Nsectorдѭ
    do
    {
        //ʼ0xFC Ƕд
        SPIx_ReadWriteByte(0xFC);	  
        //һsector
        for(i=0;i<512;i++)
        {
            SPIx_ReadWriteByte(*data++);
        }
        //2Bytedummy CRC
        SPIx_ReadWriteByte(0xff);
        SPIx_ReadWriteByte(0xff);
        
        //ȴSDӦ
        r1 = SPIx_ReadWriteByte(0xff);
        if((r1&0x1F)!=0x05)
        {
            SD_CS=1;    //ӦΪֱ˳
            return r1;
        }		   
        //ȴSDд
        if(SD_WaitDataReady()==1)
        {
            SD_CS=1;    //ȴSDдɳʱֱ˳
            return 1;
        }	   
    }while(--count);//sectorݴ  
    //0xFD
    r1 = SPIx_ReadWriteByte(0xFD);
    if(r1==0x00)
    {
        count =  0xfe;
    }		   
    if(SD_WaitDataReady()) //ȴ׼
	{
		SD_CS=1;
		return 1;  
	}
    //дɣƬѡ1
    SD_CS=1;
    SPIx_ReadWriteByte(0xff);  
    return count;   //countֵдcount=0count=1
}						  					  
//ָ,offsetʼbytesֽ								    
//:u32 sector ַsectorֵַ 
//     u8 *buf     ݴ洢ַС<=512byte
//     u16 offset  ƫ
//     u16 bytes   Ҫֽ	   
//ֵ:0 ɹ
//       otherʧ															   
u8 SD_Read_Bytes(unsigned long address,unsigned char *buf,unsigned int offset,unsigned int bytes)
{
    u8 r1;u16 i=0;  
    r1=SD_SendCommand(CMD17,address<<9,0);//Ͷ      
    if(r1)return r1;  //Ӧȷֱӷ
	SD_CS=0;//ѡSD
	if(SD_GetResponse(0xFE))//ȴSDʼ0xFE
	{
		SD_CS=1; //رSD
		return 1;//ȡʧ
	}	 
	for(i=0;i<offset;i++)SPIx_ReadWriteByte(0xff);//offsetλ 
    for(;i<offset+bytes;i++)*buf++=SPIx_ReadWriteByte(0xff);//ȡ	
    for(;i<512;i++) SPIx_ReadWriteByte(0xff); 	 //ʣֽ
    SPIx_ReadWriteByte(0xff);//αCRC
    SPIx_ReadWriteByte(0xff);  
    SD_CS=1;//رSD
	return 0;
}














